/*
 * DomenskiObjekti.java
 *
 * 02.05.2011
 *
 * @autor  Dr Sinisa Vlajic
 *
 * Katedra za softversko inzenjerstvo
 *
 * Laboratorija za softversko inzenjerstvo
 *
 * Fakultet organizacionih nauka - Beograd
 *
 */

import javax.swing.*;
import java.sql.*;
import java.io.Serializable;


class Racun implements OpstiDomenskiObjekat, Serializable
{
 String BrojRacuna;
 String NazivPartnera;
 Double UkupnaVrednost;
 boolean Obradjen;
 boolean Storniran;
 StavkaRacuna []sracun;

// POZIVA SE IZ EKRANSKE FORME RACUN - pocetak
//***koristi se***//
Racun()
  { BrojRacuna = "";
    NazivPartnera = "";
    UkupnaVrednost = new Double(0);
    Obradjen = false;
    Storniran = false;
    sracun = null;
  }
 // POZIVA SE IZ EKRANSKE FORME RACUN - kraj


// POZIVA SE IZ BROKERA BAZE PODATAKA - pocetak
//***koristi se***//
public String vratiVrednostiAtributa()
  { return "'"+ BrojRacuna + "', '" + NazivPartnera + "', " +  UkupnaVrednost.doubleValue() + ", " + Obradjen + ", " + Storniran;}

//***koristi se***//
public String postaviVrednostiAtributa()
  { return "BrojRacuna = '"+ BrojRacuna + "', NazivPartnera ='" + NazivPartnera + "', UkupnaVrednost = " +
           UkupnaVrednost.doubleValue() + ", Obradjen = " + Obradjen + ", Storniran = " + Storniran;
  }

//***koristi se***//
public String vratiImeKlase() { return "Racun";}

//***koristi se***//
public String vratiAtributPretrazivanja() { return "BrojRacuna";}

//***koristi se***//
public String vratiUslovZaNadjiSlog()
{ return " BrojRacuna = '"+ BrojRacuna + "'";
}

//***koristi se***//
public String vratiUslovZaNadjiSlogove()
  { return "";}

//***koristi se***//
public boolean Napuni(ResultSet rs)
{
  sracun = null;

  try { BrojRacuna = KonverterTipova.Konvertuj (rs,BrojRacuna, "BrojRacuna");
	    NazivPartnera = KonverterTipova.Konvertuj (rs,NazivPartnera, "NazivPartnera");
	    UkupnaVrednost = KonverterTipova.Konvertuj (rs, UkupnaVrednost, "Ukupnavrednost");
	    Obradjen = KonverterTipova.Konvertuj (rs, Obradjen, "Obradjen");
	    Storniran = KonverterTipova.Konvertuj (rs, Storniran, "Storniran");
   	  } catch(Exception e)
   	      { System.out.println(e);return false;}
  return true;
 }

//***koristi se***//
 public void Napuni(ResultSet RSslog, int brojSloga, int brojVezanogObjekta)
 { if (brojVezanogObjekta==0) sracun[brojSloga] = new StavkaRacuna(RSslog,this);}

//***koristi se***//
public void kreirajVezaniObjekat(int brojStavkiVezanogObjekta,int brojVezanogObjekta)
  { if (brojVezanogObjekta==0) sracun = new StavkaRacuna[brojStavkiVezanogObjekta];}

//***koristi se***//
public OpstiDomenskiObjekat vratiVezaniObjekat(int brojVezanogObjekta)
  {if (brojVezanogObjekta==0) return new StavkaRacuna(this); return null;}

//***koristi se***//
public int vratiBrojVezanihObjekata() {return 1;}

//***koristi se***//
public int vratiBrojSlogovaVezanogObjekta(int brojVezanogObjekta)
{ if (brojVezanogObjekta==0)
    { if (sracun == null) return 0;
      return sracun.length;
    }
  return 0;
}

//***koristi se***//
public OpstiDomenskiObjekat vratiSlogVezanogObjekta(int brojVezanogObjekta,int brojSloga)
{ if (brojVezanogObjekta==0) return sracun[brojSloga]; return null;}

//***koristi se***//
public int povecajBroj(ResultSet rs)
{ int broj;
  try {
        BrojRacuna = KonverterTipova.Konvertuj (rs,BrojRacuna, "Max");
        if (BrojRacuna == null) { postaviPocetniBroj(); return 1;}
        broj = Integer.parseInt(BrojRacuna);
        broj++;
		BrojRacuna = String.valueOf(broj);

        String 	pom1= new String("");
		for(int j=0; j<4-BrojRacuna.length(); j++)
		   { pom1 = pom1 + "0";}
		BrojRacuna = pom1 + BrojRacuna;


      } catch(Exception e)
          { System.out.println("Izuzetak kod generisanja novog broja racuna: " + e); return 0;}
   return 1;

}

//***koristi se***//
public void postaviPocetniBroj()
{ BrojRacuna = new String("0001"); }

// POZIVA SE IZ BROKERA BAZE PODATAKA - kraj


// POZIVA SE IZ KLASA ZA SO - pocetak
//***koristi se***//
public boolean vrednosnaOgranicenja() // 79,78
   { double Suma =0;
	 if (sracun == null) {UkupnaVrednost = new Double(0); return true;}
	 try { for(int i=0;i<sracun.length;i++)
		      { if (sracun[i].ProdajnaCena.doubleValue()>0 && sracun[i].Kolicina.intValue()>0)
				     { sracun[i].ProdajnaVrednost = new Double (sracun[i].ProdajnaCena.doubleValue() * sracun[i].Kolicina.intValue());
		               Suma = Suma +  sracun[i].ProdajnaVrednost.doubleValue();
				     }
				else
				     {return false;}
		      }
	       UkupnaVrednost = new Double(Suma);
		  } catch(Exception e) { return false;}
     return true;
   }

//***koristi se***//
public void Obradi(){Obradjen = true; }
//***koristi se***//
public void Storniraj(){Storniran = true;}
//***koristi se***//
public String vratiNazivNovogObjekta() {return "novi racun";}
//***koristi se***//
public String vratiNazivObjekta() {return "racun";}
// POZIVA SE IZ KLASA ZA SO - kraj

}


class StavkaRacuna implements OpstiDomenskiObjekat,  Serializable
{ Integer RB;
  String SifraProizvoda;
  Integer Kolicina;
  Double ProdajnaCena;
  Double ProdajnaVrednost;
  Racun rac;

// POZIVA SE IZ KONTROLERKIRACUN - pocetak
   StavkaRacuna(Racun rac1)
    { RB = new Integer(0);
      SifraProizvoda = new String("");
      Kolicina = new Integer(0);
      ProdajnaCena = new Double(0);
      ProdajnaVrednost = new Double(0);
      rac = rac1;
    }
// POZIVA SE IZ KONTROLERKIRACUN - kraj

// Poziva se iz Racun.Napuni() i Racun.vratiVezaniObjekat().
StavkaRacuna(ResultSet rs,Racun rac1)
    { RB = KonverterTipova.Konvertuj(rs,RB,"RB");
	  SifraProizvoda = KonverterTipova.Konvertuj(rs,SifraProizvoda,"SifraProizvoda");
	  Kolicina = KonverterTipova.Konvertuj(rs,Kolicina,"Kolicina");
	  ProdajnaCena = KonverterTipova.Konvertuj(rs,ProdajnaCena,"ProdajnaCena");
	  ProdajnaVrednost = KonverterTipova.Konvertuj(rs,ProdajnaVrednost,"ProdajnaVrednost");
	  rac = rac1;
	}


// POZIVA SE IZ BROKERA BAZE PODATAKA - pocetak
//***koristi se***//
public String vratiVrednostiAtributa()
  { return "'" + rac.BrojRacuna + "' , " + RB.intValue() + ", '" + SifraProizvoda + "', " +  Kolicina.intValue() + ", " + ProdajnaCena.doubleValue() + ", " + ProdajnaVrednost.doubleValue();}

//***koristi se***//
public String postaviVrednostiAtributa()
  { return "BrojRacuna= '"+ rac.BrojRacuna + "', RB = "+ RB.intValue() + ", SifraProizvoda ='" + SifraProizvoda + "', Kolicina = " +
             Kolicina.intValue() + ", ProdajnaCena = " + ProdajnaCena.doubleValue() + ", ProdajnaVrednost = " + ProdajnaVrednost.doubleValue();
  }

//***koristi se***//
public String vratiImeKlase() { return "StavkaRacuna";}

//***koristi se***//
public String vratiUslovZaNadjiSlog()
    { return " BrojRacuna = '" + rac.BrojRacuna + "' and RB = " + RB.intValue();}

//***koristi se***//
public String vratiUslovZaNadjiSlogove()
  { return " BrojRacuna = '" + rac.BrojRacuna + "'";}

//***ne koristi se***//
public String vratiAtributPretrazivanja() { return "";}

//***ne koristi se***//
public boolean Napuni(ResultSet RSslog)
{return false;}

//***ne koristi se***//
public int povecajBroj(ResultSet rs){return 0;}

//***ne koristi se***//
public OpstiDomenskiObjekat vratiVezaniObjekat(int brojVezanogObjekta)
  {return null;}

//***ne koristi se***//
public void Napuni(ResultSet RSslog, int brojSloga, int brojVezanogObjekta)
 { }

//***ne koristi se***//
public void kreirajVezaniObjekat(int brojStavkiVezanogObjekta,int brojVezanogObjekta)
  {}

//***ne koristi se***//
public int vratiBrojVezanihObjekata() {return 0;}

//***ne koristi se***//
public void postaviPocetniBroj(){}

//***ne koristi se***//
public OpstiDomenskiObjekat vratiSlogVezanogObjekta(int brojVezanogObjekta,int brojSloga)
{return null;}

//***ne koristi se***//
public int vratiBrojSlogovaVezanogObjekta(int brojVezanogObjekta) {return 0;}

// POZIVA SE IZ BROKERA BAZE PODATAKA - kraj


// POZIVA SE IZ KLASA ZA SO - pocetak
public boolean vrednosnaOgranicenja(){return true;}
public void Obradi(){}
public void Storniraj(){}
public String vratiNazivNovogObjekta() {return "novu stavku racuna";}
public String vratiNazivObjekta() {return "stavku racuna";}
// POZIVA SE IZ KLASA ZA SO - kraj


// POZIVA SE IZ EKRANSKE FORME - pocetak
public static String[] vratiZaglavlje()
   {  String [] s = new String [5];
	  s[0]=new String("Redni broj");
	  s[1]=new String("Sifra proizvoda");
	  s[2]=new String("Kolicina");
	  s[3]=new String("Prodajna cena");
	  s[4]=new String("Prodajna vrednost");
  	  return s;
	}

static Class[] vratiTipove()
    { return new Class []
  	  {Integer.class, String.class, Integer.class, Double.class, Double.class };
    }


 static Object[] vratiPocetneVrednosti()
     { Object [] obj = new Object [5];
  	   obj[0]=new Integer(0);
  	   obj[1]=new String("");
  	   obj[2]=new Integer(0);
  	   obj[3]=new Double(0);
  	   obj[4]=new Double(0);
  	   return obj;
     }

// POZIVA SE IZ EKRANSKE FORME - kraj
}